<?php

declare(strict_types=1);

namespace mirzaev\beejee\controllers;

use mirzaev\beejee\controllers\controller,
    mirzaev\beejee\controllers\tasksController;

use PDO;

/**
 * Контроллер основной страницы
 *
 * @package mirzaev\beejee\controllers
 * @author Arsen Mirzaev Tatyano-Muradovich <red@hood.su>
 */
final class mainController extends controller
{
    public function index(array $params)
    {
        $tasks = new tasksController;

        // Нормализация
        $page['current'] = filter_var($params['page'], FILTER_SANITIZE_NUMBER_INT);
        $page['sort'] = filter_var($params['page'], FILTER_SANITIZE_STRING);

        // Инициализация страниц заданий
        $page['count'] = $tasks->count();
        $page['current'] = filter_var($params['page'], FILTER_VALIDATE_INT, ['options' => ['default' => 1]]);
        $page['previous'] = $page['current'] > 1 ? $page['current'] - 1 : 1;
        $page['next'] = (int) $page['current'] < (int) $page['count'] ? $page['current'] + 1 : $page['current'];

        // Инициализация сортировки
        $sort = empty($params['sort']) ? 'id' : $params['sort'];

        // Генерация представления
        return $this->view->render(DIRECTORY_SEPARATOR . 'main' . DIRECTORY_SEPARATOR . 'index.html', ['page' => $page, 'sort' => $sort]);
    }
}
