function task_create(form) {
    let name = document.getElementById('task_create_panel_name').value;
    let email = document.getElementById('task_create_panel_email').value;
    let task = document.getElementById('task_create_panel_task').value;

    let body = 'name=' + encodeURIComponent(name) + '&email=' + encodeURIComponent(email) + '&task=' + encodeURIComponent(task);

    let http = new XMLHttpRequest();
    http.open('POST', '/task/create');
    http.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    http.onreadystatechange = function () {
        if (http.readyState === XMLHttpRequest.DONE && http.status === 200) {
            if (this.responseText !== '') {
                document.getElementById('task_create_warning').innerHTML = this.responseText;
                if (document.getElementById('task_create_warning').hasAttribute('style')) {
                    document.getElementById('task_create_warning').removeAttribute('style');
                    setTimeout(function () {
                        document.getElementById('task_create_warning').setAttribute('style', 'display: none;');
                    }, 3000);
                }
            } else {
                if (document.getElementById('task_create_success').hasAttribute('style')) {
                    document.getElementById('task_create_success').removeAttribute('style');
                    setTimeout(function () {
                        document.getElementById('task_create_success').setAttribute('style', 'display: none;');
                    }, 3000);
                }
                task_read();
            }
        }
    }
    http.send(body);
}

function task_read(page) {
    document.getElementById('button_forward').removeAttribute('onclick');
    document.getElementById('button_back').removeAttribute('onclick');

    if (typeof page === 'undefined') {
        page = document.getElementById('page_сurrent').innerHTML;
        if (typeof page === 'undefined') {
            page = 1;
        }
    }

    let http = new XMLHttpRequest();
    http.open('GET', '/tasks/count');
    http.onreadystatechange = function () {
        if (http.readyState === XMLHttpRequest.DONE && http.status === 200) {
            let pages_count;
            document.getElementById('pages_сount').innerHTML = pages_count = this.responseText;
            if (typeof pages_count === 'undefined') {
                document.getElementById('pages_сount').innerHTML = pages_count = page;
            }
            task_page_buttons(page, pages_count);
            task_read_request(page);
        }
    }
    http.send(null);
}

function task_read_request(page) {
    const url = new URL(window.location);
    url.searchParams.set('page', page);
    history.pushState(null, null, url);
    document.getElementById('page_сurrent').innerHTML = page;

    let http = new XMLHttpRequest();

    http.open('GET', '/tasks' + url.search)
    http.onreadystatechange = function () {
        if (http.readyState === XMLHttpRequest.DONE && http.status === 200) {
            document.getElementById('tasks').innerHTML = this.responseText;
        }
    }
    http.send(null);
}

function task_update(element) {
    let id = element.getAttribute('id');
    let name = element.children[1].innerHTML;
    let email = element.children[2].innerHTML;
    let task = element.children[3].innerHTML;

    document.getElementById('form_task_create').setAttribute('onsubmit', 'task_update_send(document.getElementById(' + id + '));  return false;')

    let update_button_task = document.getElementById('update_button_task_' + id);
    update_button_task.parentNode.removeChild(update_button_task);

    element.children[1].innerHTML = '<input type="text" class="form-control-sm">';
    element.children[2].innerHTML = '<input type="email" type="text" class="form-control-sm">';
    element.children[3].innerHTML = '<input type="text" class="form-control-sm">';

    element.children[1].children[0].value = name;
    element.children[2].children[0].value = email;
    element.children[3].children[0].value = task;

    element.children[4].innerHTML = '<button type="submit" class="p-0 task_button_update"><i class="fas fa-check mr-2 text-success"></i></button>' + element.children[4].innerHTML;
}

function task_update_send(element) {
    let id = element.getAttribute('id');
    let name = element.children[1].children[0].value;
    let email = element.children[2].children[0].value;
    let task = element.children[3].children[0].value;

    let body = 'id=' + encodeURIComponent(id) + '&name=' + encodeURIComponent(name) + '&email=' + encodeURIComponent(email) + '&task=' + encodeURIComponent(task);

    let http = new XMLHttpRequest();
    http.open('POST', '/task/update');
    http.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    http.onreadystatechange = function () {
        if (http.readyState === XMLHttpRequest.DONE && http.status === 200) {
            task_read();
        }
    }
    http.send(body);
}

function task_change_status(element) {
    let id = element.getAttribute('id');

    let body = 'id=' + encodeURIComponent(id) + '&completed=1';

    let http = new XMLHttpRequest();
    http.open('POST', '/task/update');
    http.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    http.onreadystatechange = function () {
        if (http.readyState === XMLHttpRequest.DONE && http.status === 200) {
            task_read();
        }
    }
    http.send(body);
}

function task_delete(element) {
    let id = element.getAttribute('id');

    let body = 'id=' + encodeURIComponent(id);

    let http = new XMLHttpRequest();
    http.open('POST', '/task/delete');
    http.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    http.onreadystatechange = function () {
        if (http.readyState === XMLHttpRequest.DONE && http.status === 200) {
            task_read();
        }
    }
    http.send(body);
}


function task_sort(element) {
    if (element.selectedIndex) {
        const url = new URL(window.location);
        url.searchParams.set('sort', element.value);
        history.pushState(null, null, url);

        task_read();
    }
}

function task_page_buttons(current, count) {
    let previous;
    if (current > 1) {
        previous = parseInt(current) - 1;
    } else {
        previous = current;
    }

    let next;
    if (current < count) {
        next = parseInt(current) + 1;
    } else {
        next = current;
    }

    if (current > count) {
        current = parseInt(count) - 1;
    }

    if (current < 1) {
        current = 1;
    }

    document.getElementById('button_forward').setAttribute('onclick', 'task_read(' + next + ')');
    document.getElementById('button_back').setAttribute('onclick', 'task_read(' + previous + ')');
}

document.forms.tasks_create_panel.addEventListener('submit', function (event) {
    if (document.forms.tasks_create_panel.checkValidity() === false) {
        event.preventDefault();
        event.stopPropagation();
    } else {
        task_create(document.forms.tasks_create_panel);
    }
    document.forms.tasks_create_panel.classList.add('was-validated');
}, false);

task_read();